# Generated by Django 3.1.3 on 2021-01-11 17:08

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('lims', '0082_auto_20201209_1049'),
    ]

    operations = [
        migrations.CreateModel(
            name='RequestType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50)),
                ('description', models.TextField(blank=True)),
                ('spec', models.JSONField(blank=True)),
            ],
        ),
        migrations.CreateModel(
            name='Request',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=60)),
                ('staff_comments', models.TextField(blank=True, null=True)),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='date created')),
                ('modified', models.DateTimeField(auto_now=True, verbose_name='date modified')),
                ('status', models.IntegerField(choices=[(0, 'Draft'), (1, 'Pending'), (2, 'Complete')], default=0)),
                ('parameters', models.JSONField(blank=True, null=True)),
                ('comments', models.TextField(blank=True, null=True)),
                ('priority', models.IntegerField(blank=True, null=True)),
                ('groups', models.ManyToManyField(blank=True, related_name='requests', to='lims.Group')),
                ('kind', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='requests', to='lims.requesttype')),
                ('project', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='requests', to=settings.AUTH_USER_MODEL)),
                ('samples', models.ManyToManyField(blank=True, related_name='requests', to='lims.Sample')),
                ('shipment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='requests', to='lims.shipment')),
            ],
            options={
                'verbose_name': 'Experiment Request',
                'ordering': ['priority'],
            },
        ),
    ]
